'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxReact = require('mobx-react');

var _Webform = require('../Webform');

var _Webform2 = _interopRequireDefault(_Webform);

var _Parser = require('../Parser');

var _BaseButton = require('../BaseButton');

var _BaseButton2 = _interopRequireDefault(_BaseButton);

var _Form = require('../Observables/Form');

var _Form2 = _interopRequireDefault(_Form);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SubmitButton = function SubmitButton(_ref) {
  var form = _ref.form,
      formStore = _ref.formStore,
      status = _ref.status,
      props = (0, _objectWithoutProperties3.default)(_ref, ['form', 'formStore', 'status']);

  var settings = form.settings;
  var disabled = status === _Webform2.default.formStates.PENDING;

  return _react2.default.createElement(
    'div',
    null,
    _react2.default.createElement(_BaseButton2.default, (0, _extends3.default)({
      disabled: disabled,
      label: (0, _Parser.template)(formStore, settings.form_submit_label),
      formSubmitAttributes: settings.form_submit_attributes
    }, props, {
      type: 'submit'
    }))
  );
};

SubmitButton.propTypes = {
  form: _propTypes2.default.shape({
    settings: _propTypes2.default.object.isRequired
  }).isRequired,
  status: _propTypes2.default.string.isRequired,
  formStore: _propTypes2.default.instanceOf(_Form2.default).isRequired
};

SubmitButton.defaultProps = {
  type: 'button'
};

exports.default = (0, _mobxReact.inject)('formStore')((0, _mobxReact.observer)(SubmitButton));